////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Lines - Adaptation of Lines demo from RUPUTER source code
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "icon.h"

char VersionPtr[] = "Lines";
int AppStackSize = 3000;

int LN,logic;
unsigned char style0=0x00,style1;
int x0[10],x1[10],y0[10],y1[10];
int dx0=2, dx1=-3, dy0=6, dy1=1;
int xp0=20,xp1=50,yp0=13,yp1=30;

void initLine(int num,int lg)
{
	int i;

  LN=num-1;
  if(LN>9) LN=9;

	xp0=10+(rand()&64);
	xp1=30+(rand()&64);
	yp0= 2+(rand()&64);
	yp1=20+(rand()&64);

	for (i=0;i<10;i++) {
		x0[i]=xp0; x1[i]=xp1; y0[i]=yp0; y1[i]=yp1;
	}
  LcdDrawLine(DRAW_BLACK, xp0,yp0,xp1,yp1);
}
/*
void endLine(void)
{
	int i;
  for (i=0;i<10;i++)
		x0[i]=x0[LN]; x1[i]=x1[LN]; y0[i]=y0[LN]; y1[i]=y1[LN];
  xp0=x0[0]; xp1=x1[0]; yp0=y0[0]; yp1=y1[0];
}*/

void chkWALL(int wall0,int wall1, int *X, int *dX)
{
  if(*X<wall0){  // Line screen
		*X =2*wall0-(*X);
		*dX=-((*dX)+*X/10);
//		*dX=-(*dX); // Alternative
  }else if(wall1<*X){
		*X =2*wall1-(*X);
		*dX=-(*dX);
  }
}

void LinesThread(void)
{
  MESSAGE msg;
  PID pid;
  pid.Name = VersionPtr;
  pid.EnableForeground = TRUE;
  pid.Icon = NULL;
  RimSetPID(&pid);
  RimRequestForeground(RimGetCurrentTaskID());
  initLine(10,0);

  do{
    while (RimPeekMessage() == FALSE) {
      int i, ii;
      x0[LN] += dx0;
      x1[LN] += dx1;
      y0[LN] += dy0;
      y1[LN] += dy1;

      chkWALL(0, 159, &x0[LN], &dx0); // Width
      chkWALL(0, 159, &x1[LN], &dx1); // Width
      chkWALL(0, 159, &y0[LN], &dy0); // Height
      chkWALL(0, 159, &y1[LN], &dy1); // Height

      LcdDrawLine(DRAW_WHITE, xp0,yp0,xp1,yp1);                // Erase line
      LcdDrawLine(DRAW_BLACK, x0[LN], y0[LN], x1[LN], y1[LN]); // Draw line

      xp0=x0[0]; xp1=x1[0];
      yp0=y0[0]; yp1=y1[0];
      for (i=0; i<LN; i++) {
        ii=i+1;
        x0[i]=x0[ii]; x1[i]=x1[ii];
        y0[i]=y0[ii]; y1[i]=y1[ii];
      }
      RimSleep(3);    // Slow down a little
      RimTaskYield(); // For Watchpuppy
    }

    RimGetMessage(&msg);/*
    if(msg.Device==DEVICE_KEYPAD&&msg.Event==KEY_DOWN&&msg.SubMsg==KEY_ESCAPE) {
      RibbonShowRibbon();
      RimTerminateThread();
    }*/
  }while(/*msg.Device!=DEVICE_KEYPAD&&msg.Event!=KEY_DOWN&&*/msg.SubMsg!=KEY_ESCAPE);
  RibbonShowRibbon();
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr, &IconBMP, 0, 40, LinesThread, AppStackSize);
}
